//
//  AppDelegate.swift
//  Kiban2
//
//  Created by Kaz Yoshikawa on 2015/04/30.
//  Copyright (c) 2015年 Electricwoods LLC. All rights reserved.
//

import UIKit
import CoreData

@UIApplicationMain
class AppDelegate: UIResponder, UIApplicationDelegate {

	var window: UIWindow?


	func application(application: UIApplication, didFinishLaunchingWithOptions launchOptions: [NSObject: AnyObject]?) -> Bool {

//		"☗と": .先と, "☗杏": .先杏, "☗圭": .先圭, "☗全": .先全, "☗馬": .先馬, "☗竜": .先竜,
//		"☖歩": .後歩, "☖香": .後香, "☖桂": .後桂, "☖銀": .後銀, "☖金": .後金, "☖角": .後角, "☖飛": .後飛, "☖王": .後王,

		let string =
			"☖持駒:なし\r" +
			"|☖香|☖桂|☖銀|☖金|☖王|☖金|☖銀|☖桂|☖香|\r" +
			"|　　|☖飛|　　|　　|　　|　　|　　|☖角|　　|\r" +
			"|☖歩|☖歩|☖歩|☖歩|☖歩|☖歩|☖歩|☖歩|☖歩|\r" +
			"|　　|　　|　　|　　|　　|　　|　　|　　|　　|\r" +
			"|　　|　　|　　|　　|　　|　　|　　|　　|　　|\r" +
			"|　　|　　|　　|　　|　　|　　|　　|　　|　　|\r" +
			"|☗歩|☗歩|☗歩|☗歩|☗歩|☗歩|☗歩|☗歩|☗歩|\r" +
			"|　　|▲角|　　|　　|　　|　　|　　|☗飛|　　|\r" +
			"|▲香|▲桂|☗銀|☗金|☗王|☗金|☗銀|☗桂|☗香|\r" +
			"☗持駒:なし\r"

		var captured1 = Captured(歩: 1, 香: 1, 桂: 1, 銀: 1, 金: 1, 角: 1, 飛: 2)
		println("\(captured1)")
		var intValue = captured1.integerValue
		var captured2 = Captured(integerValue: intValue)
		println("\(captured2)")



		var boards = [Board]()

		if var board = Board(string: Handicap.平手初期盤面) {
		
			println("\(board)")
			
			board = board.forward(Action.動(先後: .先手, 移動前の位置: .７七, 移動後の位置: .７六, 移動後の駒面: .歩))
			println("\(board)")

//			board = board.forward(Action.動(先後: .後手, 移動前の位置: .３三, 移動後の位置: .３四, 移動後の駒面: .歩))
//			println("\(board)")
			
//			board = board.forward(Action.動(先後: .先手, 移動前の位置: .８八, 移動後の位置: .２二, 移動後の駒面: .角))
//			board = board.forward(Action.動(先後: .先手, 移動前の位置: .８八, 移動後の位置: .３三, 移動後の駒面: .角))
//			println("\(board)")

//			println("\(board.王手か())")
			


			for i in 1...100 {
				let actions = board.全ての可能指手()
				println("\(actions)")
				let action = actions[Int(arc4random_uniform(UInt32(actions.count)))]
				println("\(action)")
				board = board.forward(action)
				println("\(board)")
				println("")
			}
			

		}
		
		
		return true
	}

	func applicationWillResignActive(application: UIApplication) {
		// Sent when the application is about to move from active to inactive state. This can occur for certain types of temporary interruptions (such as an incoming phone call or SMS message) or when the user quits the application and it begins the transition to the background state.
		// Use this method to pause ongoing tasks, disable timers, and throttle down OpenGL ES frame rates. Games should use this method to pause the game.
	}

	func applicationDidEnterBackground(application: UIApplication) {
		// Use this method to release shared resources, save user data, invalidate timers, and store enough application state information to restore your application to its current state in case it is terminated later.
		// If your application supports background execution, this method is called instead of applicationWillTerminate: when the user quits.
	}

	func applicationWillEnterForeground(application: UIApplication) {
		// Called as part of the transition from the background to the inactive state; here you can undo many of the changes made on entering the background.
	}

	func applicationDidBecomeActive(application: UIApplication) {
		// Restart any tasks that were paused (or not yet started) while the application was inactive. If the application was previously in the background, optionally refresh the user interface.
	}

	func applicationWillTerminate(application: UIApplication) {
		// Called when the application is about to terminate. Save data if appropriate. See also applicationDidEnterBackground:.
		// Saves changes in the application's managed object context before the application terminates.
		self.saveContext()
	}

	// MARK: - Core Data stack

	lazy var applicationDocumentsDirectory: NSURL = {
	    // The directory the application uses to store the Core Data store file. This code uses a directory named "com.electricwoods.Kiban2" in the application's documents Application Support directory.
	    let urls = NSFileManager.defaultManager().URLsForDirectory(.DocumentDirectory, inDomains: .UserDomainMask)
	    return urls[urls.count-1] as! NSURL
	}()

	lazy var managedObjectModel: NSManagedObjectModel = {
	    // The managed object model for the application. This property is not optional. It is a fatal error for the application not to be able to find and load its model.
	    let modelURL = NSBundle.mainBundle().URLForResource("Kiban2", withExtension: "momd")!
	    return NSManagedObjectModel(contentsOfURL: modelURL)!
	}()

	lazy var persistentStoreCoordinator: NSPersistentStoreCoordinator? = {
	    // The persistent store coordinator for the application. This implementation creates and return a coordinator, having added the store for the application to it. This property is optional since there are legitimate error conditions that could cause the creation of the store to fail.
	    // Create the coordinator and store
	    var coordinator: NSPersistentStoreCoordinator? = NSPersistentStoreCoordinator(managedObjectModel: self.managedObjectModel)
	    let url = self.applicationDocumentsDirectory.URLByAppendingPathComponent("Kiban2.sqlite")
	    var error: NSError? = nil
	    var failureReason = "There was an error creating or loading the application's saved data."
	    if coordinator!.addPersistentStoreWithType(NSSQLiteStoreType, configuration: nil, URL: url, options: nil, error: &error) == nil {
	        coordinator = nil
	        // Report any error we got.
	        var dict = [String: AnyObject]()
	        dict[NSLocalizedDescriptionKey] = "Failed to initialize the application's saved data"
	        dict[NSLocalizedFailureReasonErrorKey] = failureReason
	        dict[NSUnderlyingErrorKey] = error
	        error = NSError(domain: "YOUR_ERROR_DOMAIN", code: 9999, userInfo: dict)
	        // Replace this with code to handle the error appropriately.
	        // abort() causes the application to generate a crash log and terminate. You should not use this function in a shipping application, although it may be useful during development.
	        NSLog("Unresolved error \(error), \(error!.userInfo)")
	        abort()
	    }
	    
	    return coordinator
	}()

	lazy var managedObjectContext: NSManagedObjectContext? = {
	    // Returns the managed object context for the application (which is already bound to the persistent store coordinator for the application.) This property is optional since there are legitimate error conditions that could cause the creation of the context to fail.
	    let coordinator = self.persistentStoreCoordinator
	    if coordinator == nil {
	        return nil
	    }
	    var managedObjectContext = NSManagedObjectContext()
	    managedObjectContext.persistentStoreCoordinator = coordinator
	    return managedObjectContext
	}()

	// MARK: - Core Data Saving support

	func saveContext () {
	    if let moc = self.managedObjectContext {
	        var error: NSError? = nil
	        if moc.hasChanges && !moc.save(&error) {
	            // Replace this implementation with code to handle the error appropriately.
	            // abort() causes the application to generate a crash log and terminate. You should not use this function in a shipping application, although it may be useful during development.
	            NSLog("Unresolved error \(error), \(error!.userInfo)")
	            abort()
	        }
	    }
	}

}

